apiVersion: apps/v1
kind: Deployment
metadata:
  name: elogbook-tomcat-deployment
  namespace: {{ .Release.Namespace }}
spec:
  revisionHistoryLimit: 2
  selector:
    matchLabels:
      app: elogbook-tomcat
  template:
    metadata:
      labels:
        app: elogbook-tomcat
      annotations:
        checksum/config1: {{ include (print $.Template.BasePath "/elogbook-configmap.yaml") . | sha256sum }}
        checksum/config2: {{ include (print $.Template.BasePath "/elogbook-configmap-script.yaml") . | sha256sum }}
    spec:
      initContainers:
        - name: init-db
          image: "{{ .Values.imageDatabase.repository }}:{{ .Values.imageDatabase.tag }}"
          imagePullPolicy: Always
          env:
            - name: APP_DB_ROLE
              value: btbservice
            - name: APP_DB_PASSWORD
              value: btbservice
            - name: APP_DBNAME
              value: betriebstagebuch_{{ .Values.shortNameEnv | lower }}
            - name: PGHOST
              value: postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local
            - name: PGUSER
              value: postgres
            - name: PGPASSWORD
              valueFrom:
                secretKeyRef:
                  name: postgresql-secrets
                  key: POSTGRES_DB_PASSWORD
          command: [/initDb.sh]
          volumeMounts:
          - name: config-volume-init
            mountPath: /initDb.sh
            subPath: initDb.sh
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: Always
          name: elogbook-tomcat
          env:
            - name: JAVA_TOOL_OPTIONS
              value: "-agentlib:jdwp=transport=dt_socket,address=5000,server=y,suspend=n"
            - name: APP_DBNAME
              value: betriebstagebuch_{{ .Values.shortNameEnv | lower }}
            - name: POSTGRES_BTB_HOST
              value: jdbc:postgresql://postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local:5432/$(APP_DBNAME)
            - name: POSTGRES_BTB_DB_USER
              value: btbservice
            - name: POSTGRES_BTB_DB_PASSWORD
              value: btbservice
          ports:
            - containerPort: 5000
              name: "jvm-debug"
            - containerPort: 8080
          volumeMounts:
          - name: config-volume
            mountPath: /configElogBook/backendConfig.json
            subPath: backendConfig.json
      volumes:
        - name: config-volume
          configMap:
            name: elogbook-config
        - name: config-volume-init
          configMap:
            name: elogbook-init-script
            defaultMode: 0777
---
apiVersion: v1
kind: Service
metadata:
  name: elogbook-service
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    app: elogbook-tomcat
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080
